<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
   <meta name="Author" content="Todd Riggins">
   <meta name="GENERATOR" content="Mozilla/4.61 [en] (Win98; I) [Netscape]">
   <title>EXOTICA: HISTORY</title>
</head>

<body background="images/exotica_bg.gif" bgcolor="#000000" text="#ffffff">
<center>
<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><center><b><font color="maroon"><font size=+2>
<a NAME="HISTORY"></a>EXOTICA: HISTORY
</font></font></b></center></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

<table BORDER =1 CELLSPACING=0 CELLPADDING=0 WIDTH="90%" bgcolor="#888888" bordercolor="red">
<tr><td><b><font color="black">

Feb. 8, 2001: Version 1.6<br>
fixes:<br>
if user does not use the CFG_VIDEO_MODE function then the Exotica engine will
automatically detect if a double buffer system using the primary surface and
one back buffer surface and will see if it can all fit in the video memory, if
not, then it will store the double buffer surfaces in system memory.<p>
Note: User can use the new GET_PRIM_SURFACE_MEM function after the 
SET_VIDEO_MODE call to see what the Exotica engine stored the double
buffer surface at( in video memory or system memory ).<p>
Some bug fixes in the Euphoria extra file for 3d math. Thanks Chris Bensler for
pointing that out.<p>

added graphics rountine:<br>
&nbsp;GET_PRIM_SURFACE_MEM<p>

added midi player rountines:<br>
&nbsp;DMUSIC_INIT<br>
&nbsp;DMUSIC_RELEASE<br>
&nbsp;DMUSIC_TOGGLE_REVERB<br>
&nbsp;DMUSIC_REVERB_AVAIL<p>

Bye-bye Mod Player stuff! It exists no longer! Try converting your
mods to wave files or mp3 files. Or use the midi music.<p>

Also, haven't deleted the DirectPlay stuff yet. It was my humble attempt 
at including network communications for games, but I got lost in it. The Directplay
stuff that I have in this version will be replaced by newer DirectPlay functions
in later versions. DirectX 8 made the DirectPlay stuff "look" easier to deal with.
Please, dont use them. I will not help you with the current newtwork functions and 
they wont work over the internet anyways.<p>

<hr WIDTH="100%"><br>

5-27-2000: Version 1.5<br>
fixes:<br>
* BLIT_BITMAP stretching fixed. Also, made it to blit outside of surface area.<br>
--  Thanks Mark Honor(aka N2K) for finding that it didn't stretch right.<br>
* Changed AVI function names to MS Media Player names to reflect that<br>
--  it can play any MS Media Player formats.<p>

added graphics rountines:<br>
&nbsp;GET_NUMBER_OF_VIDEO_MODES<br>
&nbsp;CFG_VIDEO_MODE<br>
&nbsp;SAVE_BMP<br>
&nbsp;GET_SURFACE_PIXEL_FORMAT<br>
&nbsp;SET_BITMAP_TRANS_COLOR<br>
&nbsp;SET_ALL_BITMAPS_TRANS_COLOR<br>
&nbsp;BITMAP_PITCH<br>
&nbsp;BITMAP_POINTER<br>
&nbsp;CLEAR_PRIM_SURFACE<br>
&nbsp;PRIM_SURFACE_LOCK<br>
&nbsp;PRIM_SURFACE_UNLOCK<br>
&nbsp;WAIT_FOR_VB<p>

added Direct3D Immediate Mode Basic Support.<br>
There's still a lot more D3D code to be done but this<br>
should appetite the curiosity.<p>

added C doucmentation, didin't get the Exotica C SDK distrubution done yet though<p>

Writing to the surface with these routines:<br>
&nbsp;SURFACE_PITCH<br>
&nbsp;SURFACE_POINTER<br>
&nbsp;BPP<br>
has proven to be worthy of achieving it's job.<p>

on the todo list:<br>
* More 3D functions<br>
* NETWORKING using DirectPlay's overrided mode.<br>
* EXOTICA DATAFILE(EDF)<p>
on the sometime in the future todo list:<br>
*Direct3DSound and EAX<br>
*DirectMusic<br>
*ForceFeedBack<br>
*DirectSetup<br>

<hr WIDTH="100%"><br>
10-31-99: Version 1.4<br>
added for graphics:<br>
&nbsp; TRANS_BLIT_BITMAP<br>
&nbsp; TRANS_BITMAP_BLIT_BITMAP<p>
added/changed for stream functions:<br>
&nbsp; SETUP_STREAM_BUFFER<br>
&nbsp; STREAM_BUFFER_PLAY[Replaced STREAM_BUFFER_RESTART]<br>
&nbsp; STREAM_BUFFER_RESUME<br>
&nbsp; STREAM_BUFFER_STOP<br>
&nbsp; STREAM_BUFFER_VOLUME<br>
&nbsp; FREE_STREAMWAVE<p>
added/changed for debug routine:<br>
&nbsp; REPORT_MODE<p>
Planned todo for 1.5:<br>
Obviously I didn't do all of what I wanted todo in 1.4, but I have  a reason for it.
Trying to figure out how to write to a DirectX surface using Euphoria's poke routine
has worn me out with the computer freezing up on me all the time. Mabie there is a
right way to do it, but I'm totally stumped on it for now. I was also going to
seperate some DirectX unrelated code form Exotica and write them in Euphoria code.
As I look at that, it will take me a while to do. So, that is on hold for now.
Right now, I need something more fun to do with Exotica. So I will be studying on
how to implement Direct3D and DirectPlay into Exotica. After that, I will
continue with the stuff I haven't done that I said I was going to do for v1.6 and
up unless if there is a important bug that needs to be fixed with the current
version. I feel Exotica has enough to make a cool 2D game with now.<p>

<hr WIDTH="100%"><br>
10-25-99: Version 1.3<br>
added for graphics:<br>
&nbsp; GET_VIDEO_MODE_DESC<br>
&nbsp; SURFACE_WIDTH<br>
&nbsp; SURFACE_HEIGHT<br>
&nbsp; SURFACE_DEPTH<br>
&nbsp; SWITCH_TO_VMODE<br>
&nbsp; RESTORE_VMODE<br>
&nbsp; PAL_PUT_PIXEL<br>
&nbsp; RGB_PUT_PIXEL<br>
&nbsp; PAL_GET_PIXEL<br>
&nbsp; RGB_GET_PIXEL<br>
&nbsp; TRANS_BITMAP_BLITFAST<br>
&nbsp; BITMAP_BLITFAST<br>
&nbsp; BITMAP_PAL_PUT_PIXEL<br>
&nbsp; BITMAP_RGB_PUT_PIXEL<br>
&nbsp; BLIT_BITMAP<br>
&nbsp; BITMAP_BLIT_BITMAP<p>
added for input:<br>
&nbsp; JOYSTICK_CONTROL_PANEL<br>
&nbsp; MOUSE_Z<br>
&nbsp; MOUSE_B4<br>
&nbsp; MOUSE_B5<br>
&nbsp; MOUSE_B6<br>
&nbsp; MOUSE_B7<p>
fixes:<br>
-- RGB COLORS! Thanks N2K for your continuing support on helping find
these nasty bugs...<br>
-- No more plain 'ol Put_Pixel and Get_Pixel routines. Now, I have seperate
routines for these for 8bit Palette Mode and 16bit'n up RGB modes...<br>
-- Fixed the Streamming wave playback. Didn't have to rewrite the stream wave code
after all... thank goodness...<br>
-- Got rid of the J_INFO routines. That only made it more tedious to add joystick
functionality. Since, I figured a good way to incorporate J_INFO type code into the DLL itself,
they are gone now.<p>
Planned todo for Exotica Version 1.4:<br>
-- Unfortunitly, I didn't get every thing I wanted to do in version 1.3 done.
-- Plus, I decided I most likely wont do a Windows mode of Exotica. At this
time, I see it will take to much time and be a hassle for me to do. Mabie, I'll do a
windows mode to the end of Exotica when I get all the major stuff out of the way. Only,
if there is a high demand for it. Which means, there is going to have to be alot more
Exotica users than there is now.<br>
-- I'm still having trouble with drawing to the backbuffer surface directly using
Euphoria's memcopy or poke routines, might have to give up this idea.<br>
-- the BLIT_BITMAP and BITMAP_BLIT_BITMAP routines have stretching capability. My video
card doesn't have rotation hardware support, so the rotation90, 180, 270 are not going to
be included. But it does support Mirror and Flip Blits. Also, I need to make equivelant
routines that can blit with transparency.<br>
-- I still have no clue about the hardware soundbuffer sounds getting lost on other
type of soundcards than the PCI SoundBlaster Live. This happens with N2K's soundcard which
DirectX does detect his soundcard to be able to support hardware soundbuffers fully. But,
when he looses hardware sounds, DirectX doesn't detect them to be lost. So, I'm stuck with
out a clue on that issue. But, I will keep my brain cells moving about that. This is a
very important thing for me to figure out!<br>
-- Add clipping routines where you can add as many as you want and assign them specifically
to any bitmap_id that you desire. Expect a ussual slight performance slowdown when bitmaps
are being clipped.<br>
-- Add stream_id support to stream multiple streamming waves if desired.<br>
-- Seperate GDI, AVI, MIDI and CD code from DLL and add them to the ewin32_api.ew. Exotica
is suppose to deal with DirectX technology only. This will make the DLL smaller, plus, you
will get to see the related code written in Euphoria! I will have to add a couple more functions
to deal with this routines. So hopefully, you will only need to add these extra routines
to your existing GDI, AVI, MIDI and CD routines to work properly without changing there names
and parameters. We'll see. <br>
-- add more debug options...<br>
-- add any othe useful routines that can enhance what Exotica has now.<br>
-- fix any other bugs that might creep up...<p>
As ussual, the Exotica DataFile, DirectMusic, DirectPlay and Direct3D Support is on a major hold
for now until I get alot of other stuff done with Exotica first.<p>
Expect for sure that Version 1.4 to take as long as 1.3 to get released or even longer. I would
like to try to get all of my planned todo stuff done completely...<p>
Eventhough I finally got a ForceFeedBack joystick, looks like that will be my project for
Version 1.5 plus bug fixes. Mabie even DirectMusic will make it also in V1.5 ...<p>

<hr WIDTH="100%"><br>
9-26-99: Version 1.2<br>
-- Updated Documents. Also split them into smaller html files<br>
-- Added a handfull of joystick routines for finding out what the
capabilities are. Analog joysticks are now detected as well.<br>
-- Added keyboard buffered data mode with support functions.<br>
-- Added a new ERROR_MESSAGE routine to display exotica errors easier than
the message_box could.<br>
-- Added a ON_ERROR routine to help you exit the program more cleanly. Mainly this is
for when Exotica catches an internal error so then you can exit cleaner with this
function. Also ON_ERROR is also effected by the ERROR_MESSAGE routine.<br>
-- Blitting graphics outside the screen area no longer crashes. Thanks N2K for 
bringing that to my attention.<br>
-- On Exotica initialization, both screen buffers are cleared to black. I forgot
to do this. Thanks for pointing that out N2K.<br>
-- Fixed the RESUME_CD function. Now it resumes exactly where it was paused at.
Adam Weeden helped me notice that, thanks.<br>
-- Hopefully I got the MAKE_RGB routine fixed this time to produce the right colors.
Thanks N2K, for bringing that to my attention.<br>
-- Added DIK_PAUSE and DIK_BREAK keys. Has the same value of #C5. This was undocumented
in the DInput.h header file! Thanks for pointing that out to me N2K.<br>
-- DirectX 7.0 screwed my AVI playback routines. Now they are fixed.<br>
-- Added more examples<br>
-- Other minor bug fixes( actually clean up code )...<p>

Planned todo for Exotica Version 1.3:<br>
- Draw directly to the DirectDraw backbuffer with memcopy<br>
- Better Streaming Wave Support<br>
- Detect what the video modes your video card supports.
  This is needed for help with changing screen modes during a
  programs execution.<br>
- Add Stretch,Rotate 90|180|270 Degrees,Flip and Mirror Blit functions.<br>
- Add Windows mode<br>
- Still might need to fix MAKE_RGB function, let me know if it produces 
  the right colors for ya.<br>
- Still might need to fix restoring lost hardware memory soundbuffers, let
  me know if you still loose sound effects during program execution. I can't
  test it on my machine because it never happens on my PCI SBLive Card.<br>
- Fix any other bugs that arises from this version 1.2<br>
- Any new functions I might need to incorporate.<p>
The Exotica DataFile, DirectMusic, DirectPlay and Direct3D Support is on a major hold
for now until I get alot of other stuff done with Exotica first.<p>

<hr WIDTH="100%"><br>
9-6-99: Version 1.1<br>
--Split up the emain.ew file which exotica now has two sperate
files holding Exotica functions and the other Win32 fnctions.
No worries though, you still only need to include a emain.ew file in your proggy.<br>
--Added alot more direct control of DirectSound Setup(DSOUND_INIT).<br>
--Fixed CD Player routines<br>
--Added Midi Support<br>
--Added Streaming Wave Support, but need to rewrite it better.<br>
--Added CreateFont and USE_FONT routines. Still need to write info for them.<br>
--Added Mem_Copy support to blit graphics to screen the Euphoria
way. Need help! help me... help me... dunno if works...<br>
--Added Scroll_Bitmap, Blit_Rect's routines. Now we can grab
a picture from a big bitmap.<br>
--Added other routines which I forget now. Okay, Now since I
have this Doc, I'll try to keep myself updated. Doh...<br>
--Added a couple more examples and a game called 'Donuts.exw'
which was sort of ported from the DirectX SDK examples. Runs to fast for me.<br>
--A couple of minor bug fixes... <p>
Planned todo for version 1.2:<br>
-- More direct joystick support. DirectX windows mode. Rewrite
the streaming wave routines. Most likely add more Win32 routines.<br>
-- Enumerate Routines for hardware. Start working on basic Direct3D
routines. Study more on Datafile support.<br>
-- Oh... I need to split up this HTML into seperate 
files. Already to big for me... doh... <p>             

<hr WIDTH="100%"><br>
7-?-99: Released Version 1.0 to the public<br><br><br>

</font></b></td></tr>
</table>
<br>

<table BORDER =4 CELLSPACING=0 CELLPADDING=0 bgcolor="#CCCCCC" bordercolor="red">
<tr><td><b><font color="black">
<A href="e_api.html">API MAIN PAGE</A><br>
</font></b></td></tr>
</table>
<br>

</center>
</body>
</html>
